############################################################################
# Matt Rodriguez, LBNL
#Copyright (c) 2003, The Regents of the University of California,
#through Lawrence Berkeley National Laboratory 
#(subject to receipt of any required approvals from the U.S. Dept. of Energy). 
#All rights reserved. 
###########################################################################

import ConfigParser, unittest
from pyGlobus.security import GSSName
from pyGlobus.security import GSSMechs
from pyGlobus.security import GSSUsage
from pyGlobus.security import GSSBuffer
from pyGlobus.security import X509_Request


"""
Unittest for the all of the Simple GSS  classes  
"""

config = None # ConfigParser object

class GSSNameTestCase(unittest.TestCase):
    """
    Test case for the GSSName class.
    """

    def checkGSSName(self):
        global config
        print "\nGSSNameTestCase begin\n"
        if config == None:
            config = ConfigParser.ConfigParser()
            config.read("test/config.txt")
        try:
            name = GSSName()
            del name
            print "\nGSSNameTestCase completed\n"
        except GlobusException, ex:
            print "Exception occured during testing."
            assert 0, ex.args
        return

class GSSMechsTestCase(unittest.TestCase):
    """
    Test case for the GSSMechs class
    """

    def checkGSSMechs(self):
        global config
        print "\nGSSMechsTestCase begin\n"
        if config == None:
            config = ConfigParser.ConfigParser()
            config.read("test/config.txt")
        try:
            mech = GSSMechs()
            del mech
        except Exception, ex:
            print "Exception occured during testing. "
            print ex
        return

class GSSUsageTestCase(unittest.TestCase):
    """
    Test case for the GSSMechs class
    """
    def setUp(self):
        global config
        print "\nGSSUsageTestCase begin\n"
        if config == None:
            config = ConfigParser.ConfigParser()
            config.read("test/config.txt")
    def checkGSSUsage(self):
        try:
            usage = GSSUsage()
            del usage
        except Exception, ex:
            print "Exception occured during testing. "
            print ex
        return

    def checkSetUsage(self):
        try:
            usage = GSSUsage()
            usage.set_usage_initiate()
            usage.set_usage_accept()
            del usage
            
        except Exception, ex:
            print "Exception occured during testing. "
            print ex
        return

class X509RequestTestCase(unittest.TestCase):
    """
    Test case for the X509_Request class
    """
    def checkX509(self):
        print "\n X509RequestTestCase begin \n" 
        x509req = X509_Request()
        del x509req


class GSSBufferTestCase(unittest.TestCase):
    """
       Test case for the GSSBuffer class
       """
    def checkGSSBuffer(self):
        print "\n GSSBufferTestCase begin \n"
        buf = GSSBuffer()
        del buf
        print "DONE"
        
    def checkBufferSet(self):
        buf = GSSBuffer()
        tmpstr = "Cream"
        print "setting buffer to: ", tmpstr
        buf.set_buffer(tmpstr)
        output = buf.get_string()
        print "getting buffer output: ",output
        print "DONE"
        
def makeTestSuite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(GSSNameTestCase, "check"))
    suite.addTest(unittest.makeSuite(GSSMechsTestCase, "check"))
    suite.addTest(unittest.makeSuite(GSSUsageTestCase, "check"))
    suite.addTest(unittest.makeSuite(X509RequestTestCase, "check"))
    suite.addTest(unittest.makeSuite(GSSBufferTestCase, "check"))
    return suite

def main():
    unittest.main(defaultTest="makeTestSuite")


if __name__ == "__main__" : main()
    
                  

